multiplexer: splits mode requests into calls to different handlers.(3)

NAME
multiplexer: splits mode requests into calls to different handlers. - The multiplexer helper lets you split the calling chain depending on the calling mode (get vs getnext vs set). More...

  Functions
netsnmp_mib_handler * netsnmp_get_multiplexer_handler (netsnmp_mib_handler_methods *req)
returns a multiplixer handler given a netsnmp_mib_handler_methods structure of subhandlers.
int netsnmp_multiplexer_helper_handler (netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests)
implements the multiplexer helper

DETAILED DESCRIPTION

The multiplexer helper lets you split the calling chain depending on the calling mode (get vs getnext vs set).

Useful if you want different routines to handle different aspects of SNMP requests, which is very common for GET vs SET type actions.

Functionally:

GET requests call the get_method

GETNEXT requests call the getnext_method, or if not present, the get_method.

GETBULK requests call the getbulk_method, or if not present, the getnext_method, or if even that isn't present the get_method.

SET requests call the set_method, or if not present return a SNMP_ERR_NOTWRITABLE error.

FUNCTION DOCUMENTATION

  netsnmp_mib_handler* netsnmp_get_multiplexer_handler (netsnmp_mib_handler_methods * req)

returns a multiplixer handler given a netsnmp_mib_handler_methods structure of subhandlers.

Definition at line 36 of file multiplexer.c.

References netsnmp_create_handler(), and netsnmp_multiplexer_helper_handler().

  int netsnmp_multiplexer_helper_handler (netsnmp_mib_handler * handler, netsnmp_handler_registration * reginfo, netsnmp_agent_request_info * reqinfo, netsnmp_request_info * requests)

implements the multiplexer helper

Definition at line 57 of file multiplexer.c.

References netsnmp_call_handler().

Referenced by netsnmp_get_multiplexer_handler().